﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Common;

namespace HeuristicLab.Problems.Instances {
  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("13911120-9C07-40C7-9613-004995979C0C")]
  public interface IProblemInstanceConsumer : IContent { }

  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("20F82CD6-CDC2-4B67-B356-0DB32B6B2319")]
  public interface IProblemInstanceConsumer<in TData> : IProblemInstanceConsumer {
    /// <summary>
    /// Loads the given instance data.
    /// </summary>
    /// <exception cref="InvalidDataException">Thrown when the instance cannot be loaded.</exception>
    /// <param name="data">The data of the instance.</param>
    void Load(TData data);
  }
}
